"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getContainer = exports.loadSchema = exports.clearDB = exports.getDBEntities = exports.getConnectionOrm = void 0;
var core_1 = require("@mikro-orm/core");
var factory_container_1 = require("../factory-container");
var genre_factory_1 = require("./sample/factories/genre-factory");
var book_factory_1 = require("./sample/factories/book-factory");
var author_factory_1 = require("./sample/factories/author-factory");
var famous_author_factory_1 = require("./sample/factories/famous-author-factory");
var genre_1 = require("./sample/entities/genre");
var author_1 = require("./sample/entities/author");
var book_1 = require("./sample/entities/book");
/**
 * Get a sample database connection for a fake postgres database
 * @returns an instantiated database connection string
 */
var getConnectionOrm = function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, core_1.MikroORM.init({
                type: 'postgresql',
                host: process.env.ENVIRONMENT === 'ci' ? 'localhost' : 'db',
                port: 5432,
                user: 'postgres',
                password: 'example',
                dbName: 'postgres',
                debug: false,
                entities: [book_1.Book, genre_1.Genre, author_1.Author],
            })];
    });
}); };
exports.getConnectionOrm = getConnectionOrm;
/**
 * Get all of the database entities associated with a database connection
 *
 * @param connection: A database connection string
 * @returns an array of objects for name and table name
 */
var getDBEntities = function (em) {
    var entities = [];
    var metadata = em.getMetadata().getAll();
    Object.keys(metadata).forEach(function (key) {
        entities.push({
            // @ts-ignore
            name: metadata[key].name,
            tableName: metadata[key].tableName,
        });
    });
    return entities;
};
exports.getDBEntities = getDBEntities;
/**
 * Clear all database tables via connection
 *
 * @param connection: Database connection clear
 * @returns a promise that the Database has been cleared
 */
var clearDB = function (em) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, _b, entity, repository, e_1_1, err_1;
    var e_1, _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _d.trys.push([0, 14, , 15]);
                _d.label = 1;
            case 1:
                _d.trys.push([1, 7, 8, 13]);
                _a = __asyncValues(exports.getDBEntities(em));
                _d.label = 2;
            case 2: return [4 /*yield*/, _a.next()];
            case 3:
                if (!(_b = _d.sent(), !_b.done)) return [3 /*break*/, 6];
                entity = _b.value;
                repository = em.getRepository(entity.name);
                return [4 /*yield*/, repository.nativeDelete({})];
            case 4:
                _d.sent();
                _d.label = 5;
            case 5: return [3 /*break*/, 2];
            case 6: return [3 /*break*/, 13];
            case 7:
                e_1_1 = _d.sent();
                e_1 = { error: e_1_1 };
                return [3 /*break*/, 13];
            case 8:
                _d.trys.push([8, , 11, 12]);
                if (!(_b && !_b.done && (_c = _a.return))) return [3 /*break*/, 10];
                return [4 /*yield*/, _c.call(_a)];
            case 9:
                _d.sent();
                _d.label = 10;
            case 10: return [3 /*break*/, 12];
            case 11:
                if (e_1) throw e_1.error;
                return [7 /*endfinally*/];
            case 12: return [7 /*endfinally*/];
            case 13: return [3 /*break*/, 15];
            case 14:
                err_1 = _d.sent();
                throw new Error("ERROR: Cleaning test db: " + err_1);
            case 15: return [2 /*return*/];
        }
    });
}); };
exports.clearDB = clearDB;
var loadSchema = function (orm) { return __awaiter(void 0, void 0, void 0, function () {
    var generator;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                generator = orm.getSchemaGenerator();
                return [4 /*yield*/, generator.dropSchema()];
            case 1:
                _a.sent();
                return [4 /*yield*/, generator.createSchema()];
            case 2:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
exports.loadSchema = loadSchema;
/**
 * Get a stub factory container for testing
 * @returns an instantiated container
 */
var getContainer = function (em) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, factory_container_1.FactoryContainer.init({
                em: em,
                factories: [book_factory_1.BookFactory, genre_factory_1.GenreFactory, author_factory_1.AuthorFactory, famous_author_factory_1.FamousAuthorFactory],
            })];
    });
}); };
exports.getContainer = getContainer;
